<template>
  <div v-loading="loading">
    <div class="white-box">
      <el-tabs v-model="filterStatus" @tab-click="handleFilterStatusClick">
        <el-tab-pane label="全部" name="-1" :lazy="true"></el-tab-pane>
        <el-tab-pane label="待审核" name="0" :lazy="true"></el-tab-pane>
        <el-tab-pane label="审核通过" name="1" :lazy="true"></el-tab-pane>
        <el-tab-pane label="审核拒绝" name="3" :lazy="true"></el-tab-pane>
      </el-tabs>
      <div class="filter-box">
        <filter-user ref="filterUser" :filter-types.sync="filterTypes" @select-value="handleFilterUser"></filter-user>
      </div>
      <el-table class="table-box" ref="multipleTable" :data="tableData" stripe style="width: 100%;"
                @selection-change="handleSelectionChange" :height="tool.getTableHeight(true)">
        <el-table-column type="selection" width="55" v-if="tableHeaders"></el-table-column>
        <el-table-column v-for="(tableHeader, key) in tableHeaders" :key="key" :label="tableHeader.header" :width="tableHeader.other.width ? tableHeader.other.width : ''">
          <template slot-scope="scope">
            <template v-if="scope.row[tableHeader.index].other.tag" >
              <el-tag :type="scope.row[tableHeader.index].other.tag.type ? scope.row[tableHeader.index].other.tag.type : null" :size="scope.row[tableHeader.index].other.tag.size ? scope.row[tableHeader.index].other.tag.size : null" :class="scope.row[tableHeader.index].other.tag.class ? scope.row[tableHeader.index].other.tag.class : null" >{{scope.row[tableHeader.index].value}}</el-tag>
            </template>
            <template v-else-if="scope.row[tableHeader.index].other.progress" >
              <el-progress type="circle" :percentage="Number.parseInt(percentList['MOVE_PERCENT'][scope.row.ID])"
                           :width="50"
                           :stroke-width="3"></el-progress>
            </template>
            <template v-else>
              <div v-html="scope.row[tableHeader.index].value"></div>
            </template>
          </template>
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="180" v-if="tableHeaders">
          <template slot-scope="scope" v-if="scope.row.AUDIT_STATUS==='0' && (permission.hasPermission(`finance/perf-audit-pass`) || permission.hasPermission(`finance/perf-audit`) || permission.hasPermission(`finance/perf-audit-delete`))">
            <el-dropdown size="small" trigger="click">
              <el-button type="primary" size="small" @click.stop="">
                操作该数据<i class="el-icon-arrow-down el-icon--right"></i>
              </el-button>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="pass" @click.native="handleAuditShow(scope.row)" v-show="permission.hasPermission(`finance/perf-audit-pass`)">审核通过</el-dropdown-item>
                <el-dropdown-item command="refuse" @click.native="handleAudit(scope.row, 'reject')" v-show="permission.hasPermission(`finance/perf-audit`)">审核拒绝
                </el-dropdown-item>
                <el-dropdown-item command="del" @click.native="handleDel(scope.row.ID)"
                                  v-show="permission.hasPermission(`finance/balance-audit-delete`)">删除数据
                </el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
        </el-table-column>
      </el-table>
      <div class="white-box-footer">
        <el-dropdown size="small" trigger="click" @command="handleMuli" v-if="filterStatus==='0' && (permission.hasPermission(`finance/perf-audit`)||permission.hasPermission(`finance/perf-audit-delete`))">
          <el-button type="primary" size="small">
            所选数据<i class="el-icon-arrow-down el-icon--right"></i>
          </el-button>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command="pass" v-if="permission.hasPermission(`finance/perf-audit`)">批量审核</el-dropdown-item>
            <el-dropdown-item command="reject" v-if="permission.hasPermission(`finance/perf-audit`)">批量拒审</el-dropdown-item>
            <el-dropdown-item command="del" @click.native="handleDel()" v-if="permission.hasPermission(`finance/perf-audit-delete`)">批量删除</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <el-button type="primary" size="small" @click="handleAdd" icon="el-icon-plus" v-show="permission.hasPermission(`finance/perf-apply`)">申请调整会员业绩</el-button>
        <el-button type="success" size="small" @click="handleExport"
                   v-show="permission.hasPermission(`finance/perf-audit-list-export`)">导出Excel
        </el-button>
        <pagination :total="totalCount" :page_size="pageSize" @size-change="handleSizeChange" @current-change="handleCurrentChange"></pagination>
      </div>
    </div>
    <el-dialog title="审核会员余额变动信息" :visible.sync="dialogAuditFormVisible">
      <el-form :model="form" label-width="250px" class="form-dialog" v-loading="dialogAuditLoading">
        <el-form-item label="调整期数">
          <el-input v-model="form.periodNum" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="会员编号">
          <el-input v-model="userInfo.USER_NAME" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="会员姓名" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.REAL_NAME" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="一市场总网业绩" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.PV_1L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="二市场总网业绩" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.PV_2L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="三市场总网业绩" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.PV_3L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="四市场总网业绩" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.PV_4L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="五市场总网业绩" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.PV_5L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="一市场结余" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.SURPLUS_1L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="二市场结余" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.SURPLUS_2L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="三市场结余" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.SURPLUS_3L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="四市场结余" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.SURPLUS_4L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="五市场结余" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.SURPLUS_5L" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="虚拟零售区结余业绩" v-show="userInfo.REAL_NAME!==null">
          <el-input :value="userInfo.SURPLUS_LS" :disabled="true"></el-input>
        </el-form-item>

        <el-form-item label="调整类型">
          <el-select v-model="form.perfType" @change="handlePerfTypeChange">
            <el-option label="总网业绩" :value="1"></el-option>
            <el-option label="大区结余" :value="2"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="调整市场" v-if="form.perfType===1">
          <el-select v-model="form.location">
            <el-option label="一市场" :value="1"></el-option>
            <el-option label="二市场" :value="2"></el-option>
            <el-option label="三市场" :value="3"></el-option>
            <el-option label="四市场" :value="4"></el-option>
            <el-option label="五市场" :value="5"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="调整市场" v-if="form.perfType===2">
          <el-select v-model="form.location">
            <el-option label="一市场" :value="1"></el-option>
            <el-option label="二市场" :value="2"></el-option>
            <el-option label="三市场" :value="3"></el-option>
            <el-option label="四市场" :value="4"></el-option>
            <el-option label="五市场" :value="5"></el-option>
            <el-option label="虚拟零售区" :value="6"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="调整数额">
          <el-input v-model="form.amount"></el-input>
        </el-form-item>
        <el-form-item label="备注">
          <el-input type="textarea" :row="2" placeholder="请输入内容" v-model="form.remark"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogAuditFormVisible = false">取 消</el-button>
        <el-button type="primary" @click.native="handleAuditPass">通 过</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import network from '@/utils/network'
  import tool from '@/utils/tool'
  import baseInfo from '@/utils/baseInfo'
  import FilterUser from '@/components/FilterUser'
  import permission from '@/utils/permission'
  import Pagination from '@/components/Pagination'
  import filterHelper from '../../utils/filterHelper'

  export default {
    name: 'finance_perf-audit-list',
    components: {FilterUser,Pagination},
    mounted() {
      this.getData()
    },
    data() {
      return {
        tableHeaders: null,
        tableData: null,
        loading: true,
        currentPage: 1,
        totalPages: 1,
        totalCount: 1,
        pageSize: 20,
        tool: tool,
        permission: permission,
        filterData: null,
        baseDecLevels: baseInfo.decLevels(),
        baseEmpLevels: baseInfo.empLevels(),
        filterTypes: {},
        filterModel: {},
        filterStatus: '0',
        dialogAuditLoading: false,
        dialogAuditFormVisible: false,
        auditId: null,
        form: {
          periodNum: '',
          userName: '',
          perfType: 1,
          location: 1,
          amount: null,
          remark: null,
        },
        userInfo: {
          REAL_NAME: null,
          PV_1L: null,
          PV_2L: null,
          PV_3L: null,
          PV_4L: null,
          PV_5L: null,
          SURPLUS_1L: null,
          SURPLUS_2L: null,
          SURPLUS_3L: null,
          SURPLUS_4L: null,
          SURPLUS_5L: null,
        },

        auditStatus: ['未审核', '已审核', '已拒绝'],
      }
    },
    methods: {
      handlePerfTypeChange(){
        this.form.location = 1;
      },
      handleMuli(command) {
        if (this.multipleSelection.length < 1) {
          this.$message({
            message: '请选择要操作的记录',
            type: 'warning'
          })
          return;
        }
        if (command === 'pass') {
          this.handleAudit(null, 'true')
        } else if (command === 'reject') {
          this.handleAudit(null, 'reject')
        }
      },
      handleAuditShow(row) {
        this.dialogAuditLoading = true
        this.auditId = row.ID
        this.dialogAuditFormVisible = true
        let vueObj = this
        network.getData('finance/perf-audit-get', {id: this.auditId}).then(response => {
          vueObj.dialogAuditLoading = false
          vueObj.userInfo = response.userInfo
          vueObj.form = response.perfAudit
          vueObj.form.perfType = Number.parseInt(response.perfAudit.perfType)
          vueObj.form.location = Number.parseInt(response.perfAudit.location)
        })
      },
      handleAuditPass() {
        this.dialogAuditFormVisible = false
        this.$message({
          message: '正在通过审核',
          type: 'info'
        })
        this.form.auditStatus = 'true'
        let path = 'finance/perf-audit-pass'
        network.postData(path, this.form).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {
        })
      },
      handleAudit(row = null, status) {
        let obj = this
        let title = '确定要通过审核？备注：'
        if (status === 'reject') {
          title = '确定要拒绝审核？备注：'
        }
        this.$prompt(title, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          inputValue: row ? row.REMARK : '',
          //type: 'warning',
        }).then(({value}) => {
          let selectedIds = []
          if (row === null) {
            for (let val of obj.multipleSelection) {
              selectedIds.push(val.ID)
            }
          } else {
            selectedIds.push(row.ID)
          }
          return network.postData(`finance/perf-audit`, {
            selected: selectedIds,
            remark: value,
            auditStatus: status
          })
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {

        })
      },
      handleDel(id = null) {
        let obj = this
        this.$confirm('确定删除选定的数据？', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          let selectedIds = []
          if (id === null) {
            for (let val of obj.multipleSelection) {
              selectedIds.push(val.ID)
            }
          } else {
            selectedIds.push(id)
          }
          return network.postData(`finance/perf-audit-delete`, {
            selected: selectedIds
          })
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          obj.getData(obj.currentPage, obj.pageSize)
        }).catch(response => {

        })
      },
      handleSelectionChange(val) {
        this.multipleSelection = val
      },
      handleCurrentChange(page) {
        this.getData(page, this.pageSize)
      },
      handleSizeChange(pageSize) {
        this.getData(this.currentPage, pageSize)
      },
      handleFilter(model) {
        this.filterData = model
        this.getData(1, this.pageSize)
      },
      handleAdd() {
        this.$router.push('/finance/perf-apply')
      },
      handleFilterStatusClick(tab, event) {
        filterHelper.clearFilterOption(this)
        this.getData()
      },
      handleFilterUser(filterData) {
        filterHelper.handleFilterUser(this, filterData)
      },
      handleFilter() {
        this.getData()
      },
      getData(page, pageSize) {
        let filterData = this.filterModel
        filterData.filterStatus = this.filterStatus != '-1' ? `=,${this.filterStatus}` : ''
        let vueObj = this
        network.getPageData(this, 'finance/perf-audit-list', page, pageSize, filterData, function (response) {
          vueObj.allData = response
          vueObj.filterTypes = response.filterTypes
        })
      },
      onMessageCallback() {
        this.getData(this.currentPage, this.pageSize)
      },
      handleExport(){
        this.$confirm(`确定要导出当前数据吗？`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          return network.getData(`finance/perf-audit-list-export`, this.filterModel)
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
        }).catch(response => {

        })
      },
    }
  }

</script>

<style scoped>
  .table-box .el-form-item__label {
    width: 100px;
    color: #99a9bf;
  }

  .table-box .el-form-item {
    width: 30%;
    margin-right: 0;
    margin-bottom: 0;
  }
</style>
